package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.cache.CacheContext;
import com.ims.eval.dao.IndicatorDictionaryMapper;
import com.ims.eval.dao.result.CustomException;
import com.ims.eval.entity.IndicatorDictionary;
import com.ims.eval.service.IIndicatorDictionaryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


import java.util.Date;
import java.util.List;

/**
 * <p>
 * 指标字典表 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-02-26
 */
@Service
public class IndicatorDictionaryServiceImpl extends ServiceImpl<IndicatorDictionaryMapper, IndicatorDictionary> implements IIndicatorDictionaryService {

	@Autowired
	private CacheContext cache;

	public  List<IndicatorDictionary>  list(String id,String indicatorId,String optionCode,String optionName){
		QueryWrapper<IndicatorDictionary> qw = new QueryWrapper<>();

		if (StringUtils.isNotEmpty(id)) {
			qw.lambda().eq(IndicatorDictionary::getId, id);
		}

		if (StringUtils.isNotEmpty(indicatorId)) {
			qw.lambda().eq(IndicatorDictionary::getIndicatorId, indicatorId);
		}
		if (StringUtils.isNotEmpty(optionCode)) {
			qw.lambda().eq(IndicatorDictionary::getOptionCode, optionCode);
		}
		if (StringUtils.isNotEmpty(optionName)) {
			qw.lambda().like(IndicatorDictionary::getOptionName, optionName);
		}
		List<IndicatorDictionary> list = baseMapper.selectList(qw);

		return list;
	}

	@Override
	public boolean saveOrUpdate(IndicatorDictionary entity) {

		if (null != entity && (null == entity.getId() || "".equals(entity.getId().trim()))) {
			QueryWrapper<IndicatorDictionary> qw = new QueryWrapper<>();
			qw.lambda().eq(IndicatorDictionary::getIndicatorId, entity.getIndicatorId());
			qw.lambda().eq(IndicatorDictionary::getOptionCode, entity.getOptionCode());
			List<IndicatorDictionary> list = baseMapper.selectList(qw);
			if (null != list && list.size() > 0) {
				throw new CustomException("当前属性code已存在");
			}
			entity.setCreateTime(new Date());
		} else {
			entity.setUpdateTime(new Date());
		}
		entity.setOptionName(null == CacheContext.ddNameMap.get(entity.getOptionCode()) ? "未知属性" : CacheContext.ddNameMap.get(entity.getOptionCode()));
		return super.saveOrUpdate(entity);
	}


}
