/**
 *
 */
package com.ims.eval.controller;

import com.ims.core.controller.WebController;
import com.ims.core.utils.StringUtils;
import com.ims.eval.entity.EvaluateRule;
import com.ims.eval.service.IEvaluateRuleService;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * 考评规则Controller
 * @author wang
 * @version 2023-02-23
 */
@Controller
@RequestMapping(value = "/eval/evaluateRule")
public class EvaluateRuleController extends WebController<IEvaluateRuleService,EvaluateRule> {

 	//@ImsPreAuth("eval:evaluateRule:view")
	@RequestMapping(value = "list")
	public String list(EvaluateRule evaluateRule, Model model) {
		return "ims/ims-eval${ims_eval_suffix}/eval/evaluateRuleList";
	}

    //@ImsPreAuth("eval:evaluateRule:view")
	@RequestMapping(value = "form")
	public String form(EvaluateRule evaluateRule, Model model) {
	    String formView = evaluateRule.getFormView();
	    if(StringUtils.isNotBlank(formView)){
			return "ims/"+formView;
		}
		return "ims/ims-eval${ims_eval_suffix}/eval/evaluateRuleForm";
	}

    //@ImsPreAuth("eval:evaluateRule:view")
	@RequestMapping(value = "lov")
	public String lov(EvaluateRule evaluateRule, Model model) {
		return "ims/ims-eval${ims_eval_suffix}/eval/evaluateRuleList";
	}

    //@ImsPreAuth("eval:evaluateRule:view")
	@RequestMapping(value = "data")
	@ResponseBody
	public String getData(EvaluateRule evaluateRule, HttpServletRequest request, HttpServletResponse response, Model model)  throws IOException  {
        return  super.getData(evaluateRule,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateRule:view")
	@RequestMapping(value = "allData")
	@ResponseBody
	public String getAllData(EvaluateRule evaluateRule, HttpServletRequest request, HttpServletResponse response, Model model)  throws IOException  {
        return  super.getAllData(evaluateRule,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateRule:view")
	@RequestMapping(value = "get")
	@ResponseBody
	public String get(EvaluateRule evaluateRule, HttpServletRequest request, HttpServletResponse response, Model model) throws IOException {
        return  super.get(evaluateRule,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateRule:edit")
	@RequestMapping(value = "initInsert")
	@ResponseBody
	public String initInsert(EvaluateRule evaluateRule, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.initInsert(evaluateRule,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateRule:edit")
	@RequestMapping(value = "checkSave")
	@ResponseBody
	public String checkSave(EvaluateRule evaluateRule, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.checkSave(evaluateRule,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateRule:edit")
	@RequestMapping(value = "save")
	@ResponseBody
	public String save(EvaluateRule evaluateRule, Model model,  HttpServletRequest request, HttpServletResponse response) {
		 return super.save(evaluateRule,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateRule:remove")
	@RequestMapping(value = "checkRemove")
	@ResponseBody
	public String checkRemove(EvaluateRule evaluateRule, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.checkRemove(evaluateRule,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateRule:remove")
	@RequestMapping(value = "remove")
	@ResponseBody
	public String remove(EvaluateRule evaluateRule, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.remove(evaluateRule,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateRule:edit")
	@RequestMapping(value = "import",produces=MediaType.APPLICATION_JSON_UTF8_VALUE)
	@ResponseBody
	public String importFile(EvaluateRule evaluateRule,MultipartFile excelFile, HttpServletRequest request, HttpServletResponse response) {
         return super.importFile(evaluateRule,excelFile,null,request,response);
	}

    //@ImsPreAuth("eval:evaluateRule:view")
	@RequestMapping(value = "export", method= RequestMethod.POST)
	public void exportFile(EvaluateRule evaluateRule, HttpServletRequest request, HttpServletResponse response) {
         super.exportFile(evaluateRule,request,response );
	}

}
